#ifndef AI_H
#define AI_H

#include <stdio.h>
#include "Constants.h"
#include "GameRules.h"
#include "PoolRoom.h"
#include "PlayingBall.h"
#include "GameManager.h"
#include <math.h>

class AI
{
public:
	AI(GameRules *gamerules, GameManager *gamemanager, PoolRoom *poolroom);
	~AI();
	void Play(PlayingBall *cue);

private:
	int difficulty;
	GameRules *rules;
	PoolRoom *room;
    GameManager *manager;
    float distance;

	float CalculateAngle(float x1, float z1, float x2, float z2);
	float CalculateDistance(float x1, float z1, float x2, float z2);
	void CalculateTargetPosition(float *targetX, float *targetZ, float pocketX, float pocketZ, float ballX, float ballZ, float angle);//float distance, float angle);
    void CalculatePosition(float &x, float &z, float fromx, float fromz, float angle, float dist);
    float To360Angle(float angle, float x1, float z1, float x2, float z2);
    float DegToRad(float angle);
    float RadToDeg(float angle);
};

#endif