//Camera.h
//
//Camera class. Pretty self explanatory really.

#ifndef CAMERA_H
#define CAMERA_H

#include <render/render.h>
#include <geommath/geommath.h>
#include "Constants.h"

class Camera
{
public:
    Camera();
    ~Camera();

    Mat44 MakeWorldToScreenMatrix(float centreX, float centreY, float centreZ);
    void  RotateCamera(float dx, float dy, float dz);
    void  GetCameraVector(float resultVec[3]);
    float GetXRotation();
    float GetYRotation();
    float GetZRotation();
    float GetXOffset();
    float GetYOffset();
    float GetZOffset();
    void  Zoom(float amount);
    void  ResetCamera();
    Mat44 MakeCueMatrix(float centreX, float centreY, float centreZ);
    void  RestrictCamera(bool doRestrict);
    void  SetMaxAngle(float newMaxAngle);
    void  SetMinAngle(float newMinAngle);

private:
    void  InitialiseVariables();
       
    bool  restrictCamera;
    float maxAngle, minAngle;
    float offsetX, offsetY, offsetZ, rotX, rotY, rotZ, minZoom, maxZoom, cueZOffset;
    Mat44 cameraToScreen, tempWC, tempWC2, tempWC3, tempWC4;
};

#endif
