//Constants.h
//
//Contains all the constants that are used across multiple classes in the PINP project

#ifndef CONSTANTS_H
#define CONSTANTS_H

#include <sps2lib.h>
#include <sps2tags.h>
#include <sps2util.h>
#include <sps2regstructs.h>
#include "PS2Defines.h"
#include "AddRegisters.h"

#define PRIMITIVEMEM_4K		0
#define TEXTUREMEM_256K		(KILOBYTES(4))
#define TEXTUREDMAMEM_4K	(KILOBYTES(132))//260))
#define TOTALMEMNEEDED		(KILOBYTES(136))//264))

struct Bitmap
{
    int iQWC;
	Dn_CHCR_t chcr;
	Dn_MADR_t madr;
	sps2Memory_t *pMemCached;
	char *pcMemory;
    int w, h;
    char *name;
    bool loaded;
    unsigned long texDmaMemNeeded, totalMemNeeded;  
};

enum CollisionType
{
    BallBall    = 0,
    BallRoom    = 1,
    BallCushion = 2,
    BallPocket  = 3
};

#define PI         3.14159265358
#define TWOPI      6.2831853071
#define HALFPI     1.57079632679
#define MAX_SOUNDS 10
#define MAX_BALLS  30

#define MENU_START1PLAYER  0
#define MENU_START2PLAYERS 1
#define MENU_OPTIONS       2
#define MENU_EXIT          3

#define GAMESTATE_PLAYING	  0    //BALLZ AREZ MOVINGZ!
#define GAMESTATE_MENU	  	  1	 //We're in the menu
#define GAMESTATE_EXITING	  2	 //We're about to jump out of the loop
#define GAMESTATE_WAITING     3	// Player!, Make a move!
#define GAMESTATE_SHOWRESULTS 4 //Game over. Show winners, then go to menu
#define GAMESTATE_APPSTART    5 //Only used to ensure player has to select a game and can't just leave the menu
#define GAMESTATE_ANIMATECUE  6 //Cue is hitting the ball
#define GAMESTATE_INTRO		  7
#define GAMESTATE_OUTRO		  8

#define EVENT_BALLROOM      0
#define EVENT_BALLPOCKET    1
#define EVENT_BALLBALL		2

#define BALL_BIG	  0
#define BALL_SMALL	  1
#define	BALL_BLACK    2
#define BALL_WHITE	  3
#define BALL_NOTARGET -1
#define BALL_NOOPPOSITE -2
#define SCALE_FACTOR 6350

#endif
