//Credits.cpp

#include "Credits.h"

Credits::Credits(char* creditsFile)
{
    for(int i = 0; i < MAX_STRINGS; i++)
        textStrings[i] = NULL;
    numStrings = 0;
    LoadCreditsFile(creditsFile);
}

Credits::~Credits()
{
    for(int i = 0; i < MAX_STRINGS; ++i)
        if(textStrings[i] != NULL)
            free(textStrings[i]);
}

void Credits::ShowCredits()
{
    int currentYPos = 100;
    int deltaYBigHeading = 35;
    int deltaYSmallHeading = 30;
    int deltaYSpacing = 25;
        
    for(int i = 0; i < numStrings; ++i)
    {
        switch(textStrings[i][0])
        {
            case ' ':
            case '\0':
            case '\n':
            case '\r':
                currentYPos += deltaYSpacing;
                break;

            case '#':
                PrintCenteredString(&(textStrings[i][1]), &fontHelvetica24, currentYPos);
                currentYPos += deltaYBigHeading;
                break;
        
            case '*':
                PrintCenteredString(&(textStrings[i][1]), &fontHelvetica18, currentYPos);
                currentYPos += deltaYSmallHeading;
                break;

            default:
                PrintCenteredString(textStrings[i], &fontHelvetica14, currentYPos);
                currentYPos += deltaYSpacing;
                break;
        }
    }

    if(numStrings == 0)
        PrintCenteredString("Couldn't load credits.txt file", &fontHelvetica18, currentYPos);
}

void Credits::LoadCreditsFile(char* fileName)
{
    FILE *filePtr;
    char line[MAX_STR_LEN];
    int  length;

    if((filePtr = fopen(fileName, "r")) == NULL)
        return; //Couldn't open file

    while(!feof(filePtr))
    {
        if(fgets(line, MAX_STR_LEN, filePtr) != NULL)
        {
            length = strlen(line);
            if(line[length - 1] == '\n')
            {
                length--;
                line[length] = '\0';
            }

            textStrings[numStrings] = (char*)malloc(length + 1);
            if(textStrings[numStrings] != NULL)
            {
                //Memory allocated successfully - copy string into new memory
                char *textPtr = textStrings[numStrings];
                for(int i = 0; i < (length + 1); ++i)
                    textPtr[i] = line[i];        
                numStrings++;
            }
        }
    }

    fclose(filePtr);
}

void Credits::PrintCenteredString(char* str, sps2UFontStruct* font, int y)
{
    static int centreXPos = 320;
    sps2UPrintfSetPos(centreXPos - (sps2UPrintfStringWidth(font, str) / 2), y);
    int a = sps2UPrintf(font, "\377FFFFFF%s", str);
}
