#ifndef DEBUGGER_H
#define DEBUGGER_H

#include "CObject.h"
#include "Camera.h"
#include "PoolRoom.h"
#include "GameRules.h"
#include "PlayingBall.h"
#include "PlayingSurface.h"
#include "sock.h"
#include "Constants.h"

class Debugger
{
private:
	SocketController *s;
	int ticker;

	PoolRoom *p;
	Camera *c;
	GameRules *g;

public:
	Debugger();
	~Debugger();

	void TraverseTree(CObject* obj);
	void SetPoolRoom(PoolRoom *pr);
	void SetCamera(Camera *cam);
	void SetGameRules(GameRules *gr);

	bool keepgoing;
	int SockNo;
	void Post(char msg[BUFLEN]);
	void PostData(char msg[BUFLEN]);
	void UpdateAll();
	bool OhPlease();
	int interval, z;
protected:

};
#endif