//Implementation of GameRules class

#include "GameRules.h"

GameRules::GameRules()
{
    numBalls = 16;
	surfaceModel = "pooltable5";
    utensilModel = "poolcue3";

    ballSize = 0.0285;
    ballY    = ballSize;
    ballMass = 0.17;

	ballX[0] = 0.0;
	ballZ[0] = 0.8;
    ballModel[0] = "ballcue";
	ballName[0] = "Cue Ball";
	ballType[0] = BALL_WHITE;

	ballX[1] = 0.0;
	ballZ[1] = -0.62;
    ballModel[1] = "ball1";
	ballName[1] = "1 Ball";
	ballType[1] = BALL_SMALL;

	ballX[2] = 0.03;
	ballZ[2] = -0.68;
    ballModel[2] = "ball2";
	ballName[2] = "2 Ball";
	ballType[2] = BALL_SMALL;

	ballX[3] = -0.03;
	ballZ[3] = -0.68;
    ballModel[3] = "ball3";
	ballName[3] = "3 Ball";
	ballType[3] = BALL_SMALL;

	ballX[4] = 0.06;
	ballZ[4] = -0.74;
    ballModel[4] = "ball4";
	ballName[4] = "4 Ball";
	ballType[4] = BALL_SMALL;

	ballX[5] = 0.0;
	ballZ[5] = -0.74;
    ballModel[5] = "ball5";
	ballName[5] = "5 Ball";
	ballType[5] = BALL_SMALL;

	ballX[6] = -0.06;
	ballZ[6] = -0.74;
    ballModel[6] = "ball6";
	ballName[6] = "6 Ball";
	ballType[6] = BALL_SMALL;

	ballX[7] = 0.03;
	ballZ[7] = -0.8;
    ballModel[7] = "ball7";
	ballName[7] = "7 Ball";
	ballType[7] = BALL_SMALL;

	ballX[8] = -0.03;
	ballZ[8] = -0.8;
    ballModel[8] = "ball8";
	ballName[8] = "8 Ball";
	ballType[8] = BALL_BLACK;

    ballX[9] = -0.09;
	ballZ[9] = -0.8;
    ballModel[9] = "ball9";
	ballName[9] = "9 Ball";
	ballType[9] = BALL_BIG;

    ballX[10] = 0.09;
	ballZ[10] = -0.8;
    ballModel[10] = "ball10";
	ballName[10] = "10 Ball";
	ballType[10] = BALL_BIG;

    ballX[11] = -0.12;
	ballZ[11] = -0.86;
    ballModel[11] = "ball11";
	ballName[11] = "11 Ball";
	ballType[11] = BALL_BIG;

    ballX[12] = -0.06;
	ballZ[12] = -0.86;
    ballModel[12] = "ball12";
	ballName[12] = "12 Ball";
	ballType[12] = BALL_BIG;

    ballX[13] = 0.0;
	ballZ[13] = -0.86;
    ballModel[13] = "ball13";
	ballName[13] = "13 Ball";
	ballType[13] = BALL_BIG;

    ballX[14] = 0.06;
	ballZ[14] = -0.86;
    ballModel[14] = "ball14";
	ballName[14] = "14 Ball";
	ballType[14] = BALL_BIG;

    ballX[15] = 0.12;
	ballZ[15] = -0.86;
    ballModel[15] = "ball15";
	ballName[15] = "15 Ball";
	ballType[15] = BALL_BIG;

	numPockets = 6;

    pocketY = 0.05;

	pocketX[0] = -0.7;
	pocketZ[0] = -1.3;
	pocketName[0] = "Corner Pocket 1";
    pocketRadius[0] = 0.167;

	pocketX[1] = -0.7;
	pocketZ[1] = 1.3;
	pocketName[1] = "Corner Pocket 2";
    pocketRadius[1] = 0.167;

	pocketX[2] = 0.7;
	pocketZ[2] = 1.3;
	pocketName[2] = "Corner Pocket 3";
    pocketRadius[2] = 0.167;

	pocketX[3] = 0.7;
	pocketZ[3] = -1.3;
	pocketName[3] = "Corner Pocket 4";
    pocketRadius[3] = 0.167;

	pocketX[4] = -0.7;
	pocketZ[4] = 0.0;
	pocketName[4] = "Side Pocket 1";
    pocketRadius[4] = 0.07;

	pocketX[5] = 0.7;
	pocketZ[5] = 0.0;
	pocketName[5] = "Side Pocket 2";
    pocketRadius[5] = 0.07;

    numSoundFiles = 6;
    soundFiles[0] = "./sounds/fart4.wav";
    soundFiles[1] = "./sounds/ballball.wav";
    soundFiles[2] = "./sounds/fart4.wav";
    soundFiles[3] = "./sounds/ballcushion.wav";
    soundFiles[4] = "./sounds/ballsunk.wav";
	soundFiles[5] = "./sounds/cuehitball.wav";

    removalOffset = 100.02;
}

GameRules::~GameRules()
{}

int GameRules::GetNumberBalls()
{
    return numBalls;
}

char* GameRules::GetSurfaceModel()
{
	return surfaceModel;
}

char* GameRules::GetUtensilModel()
{
    return utensilModel;
}

float GameRules::GetBallX(int ball)
{
	return ballX[ball];
}

float GameRules::GetBallY(int ball)
{
	return ballY;
}

float GameRules::GetBallZ(int ball)
{
	return ballZ[ball];
}

char* GameRules::GetBallModel(int ball)
{
	return ballModel[ball];
}

float GameRules::GetBallSize(int ball)
{
	return ballSize;
}

float GameRules::GetBallMass(int ball)
{
	return ballMass;
}

int GameRules::GetNumberPockets()
{
	return numPockets;
}

float GameRules::GetPocketX(int pocket)
{
	return pocketX[pocket];
}

float GameRules::GetPocketY(int pocket)
{
	return pocketY;
}

float GameRules::GetPocketZ(int pocket)
{
	return pocketZ[pocket];
}

float GameRules::GetPocketRadius(int pocket)
{
	return pocketRadius[pocket];
}

char* GameRules::GetBallName(int ball)
{
	return ballName[ball];
}
char* GameRules::GetPocketName(int pocket)
{
	return pocketName[pocket];
}

void GameRules::LoadSounds(SoundSystem* soundSystem)
{
    for( int i = 0; i < numSoundFiles; ++i )
		sounds[i] = soundSystem->LoadSound(soundFiles[i]);
}

int GameRules::GetSound(SoundType sType)
{
    return sounds[sType];
}

int GameRules::GetBallType(int ball)
{
	return ballType[ball];
}

float GameRules::GetRemovalOffset()
{
    return removalOffset;
}

int GameRules::GetOppositeType(int type)
{
    if(type == BALL_SMALL)
        return BALL_BIG;
    if(type == BALL_BIG)
        return BALL_SMALL;

    return BALL_NOOPPOSITE;
}
