//GameRules.h

#ifndef GAMERULES_H
#define GAMERULES_H

#include <stdio.h>
#include "SoundSystem.h"
#include "Constants.h"

class GameRules
{
public:
    enum SoundType
    {
        Music       = 0,
        BallBall    = 1,
        BallRoom    = 2,
        BallCushion = 3,
        BallPocket  = 4,
		CueBall		= 5
    };

    GameRules();
    ~GameRules();

    int GetNumberBalls();
	char* GetSurfaceModel();
    char* GetUtensilModel();
	float GetBallX(int ball);
	float GetBallY(int ball);
	float GetBallZ(int ball);
	int GetNumberPockets();
	float GetPocketX(int pocket);
	float GetPocketY(int pocket);
	float GetPocketZ(int pocket);
	char* GetBallModel(int ball);
	float GetBallSize(int ball);
	float GetBallMass(int ball);
	char* GetBallName(int ball);
	char* GetPocketName(int pocket);
	float GetPocketRadius(int pocket);
    int   GetBallType(int ball);
    float GetRemovalOffset();
    int   GetOppositeType(int type);

    void  LoadSounds(SoundSystem* soundSystem);
    int GetSound(SoundType sType);

private:
    int numBalls;
	int numPockets;
	char* surfaceModel;
    char* utensilModel;
	float ballX[16];
    float ballY;
	float ballZ[16];
	char* ballModel[16];
	float ballMass;
	float ballSize;
	char* ballName[16];
    int   ballType[16];
	float pocketX[6];
	float pocketY;
	float pocketZ[6];
	float pocketRadius[6];
	char* pocketName[6];
    float removalOffset;

    char* soundFiles[MAX_SOUNDS];
	int sounds[MAX_SOUNDS];
    int   numSoundFiles;
};

#endif

