#include "GeomController.h"

GeomController::GeomController()
{
	numGeoms = 0;
}

GeomController::~GeomController()
{}

char* GeomController::GetGeomType(dGeomID geom)
{
	int num = -1;

	for (int i = 0; i < numGeoms; i++)
	{
		if (geomArray[i] == geom)
		{
			num = i;
			break;
		}
	}

	if( num == -1 )
      return NULL;
   else
      return typeArray[num];
}

void* GeomController::GetGeomObject(dGeomID geom)
{
	int num = -1;

	for (int i = 0; i < numGeoms; i++)
	{
		if (geomArray[i] == geom)
		{
			num = i;
			break;
		}
	}

	if( num == -1 )
      return NULL;
    else
      return objRefArray[num];
}

void GeomController::AddGeom(dGeomID geom, char* type, void* objRef)
{
	bool alreadyExists = false;

	for (int i = 0; i < numGeoms; i++)
	{
		if (geomArray[i] == geom)
		{
			alreadyExists = true;
			break;
		}
	}

	if (!alreadyExists && (numGeoms < MAX_GEOMS))
	{
		geomArray[numGeoms] = geom;
		typeArray[numGeoms] = type;
		objRefArray[numGeoms] = objRef;
		numGeoms++;
	}
}

void GeomController::RemoveGeom(dGeomID geom)
{
    for(int i = 0; i < numGeoms; i++)
    {
        if(geomArray[i] == geom)
        {
            for(int j = i; j < numGeoms - 1; ++j)
            {
                geomArray[j]   = geomArray[j + 1];
                typeArray[j]   = typeArray[j + 1];
                objRefArray[j] = objRefArray[j + 1];
            }
            --numGeoms;
            break;
        }
    }
}
