#ifndef HUD_H
#define HUD_H

#include <sps2lib.h>
#include <sps2util.h>
#include <sps2tags.h>
#include "TextureManager.h"
#include "fontCourier.h"
#include "fontHelvetica14.h"
#include "fontHelvetica18.h"
#include "fontHelvetica24.h"
#include "Constants.h"
#include "GameManager.h"
#include "Credits.h"

#define MAX_MENU_ITEM 4

typedef int vertex_t[2];
typedef int color_t[3];

class HUD
{
private:
	int menuItem, menuItemY[MAX_MENU_ITEM];
    int desc;
    TextureManager *texman;
	GameManager	   *gameManager;
    char* targets[5];
    float shootingForce, maxForce;
    int cPlayer, playerY[2];
    sps2Memory_t *pMemory;    // Will store information about memory we allocate
	int introLogoX, introLogoY, introTextX, introTextY, introMoveDelta;
	char* introString;
    Credits *credits;
    void DrawPowerMeter(int x, int y, float shotStrength);
    void DrawTargetGroup(int targetGroup, int x, int y);
    void DrawQuad(int x, int y, int w, int h, int z);
    int loadTriangleData(void *pvBase, int x, int y, int w, int h, int z);

public:
    HUD(TextureManager *t, GameManager *ptrGameManager, int sps2d);
    ~HUD();
	void drawHUD(int gamestate, int sockNo);
	void drawMenu();
	void changeMenuItem(int dir);
	int getCurrentSelection();
    void setShootingForce(float force);
    void setMaxForce(float maxForce);
};

#endif