//InputSystem.h
//
//Class used to handle gathering and processing of player input

#ifndef INPUT_SYSTEM_H
#define INPUT_SYSTEM_H

#include <linux/ps2/pad.h>
#include "joypadlib.h"
#include "PlayingBall.h"
#include "PoolRoom.h"
#include "Camera.h"
#include "Constants.h"
#include "SoundSystem.h"
#include "GameRules.h"
#include "HUD.h"
#include "GameManager.h"

#include "AI.h"

class InputSystem
{
public:
    InputSystem(PoolRoom *ptrPoolRoom, Camera *ptrCamera, SoundSystem *ptrSoundSystem, GameRules *ptrGameRules, HUD *ptrHUD, GameManager *ptrGameManager);
    ~InputSystem();

    void  CheckInput(int &gamestate);
    float getShootingForce();
    
private:
    unsigned long buttons, megaButton, largeButton, smallButton, musicButton;
    unsigned long menuButton, menuSelectButton, menuDownButton, menuUpButton;
    float         leftStick[2], rightStick[2], *aimStick, *zoomStick;
    float         smallForce, largeForce, megaForce, zoomSpeed, shotVec[3];
    float         shootingForce, shootingForceInc;
    float         menuToggleInterval, elapsedMenuInterval;
    bool          menuPressedToggle, musicPressedToggle, resetPressedToggle;
    bool          menuUpToggle, menuDownToggle, menuSelectToggle;
    bool          shootBtnPressed;
    bool          aiplayer;
    int           prevGamestate;
    PoolRoom      *poolRoom;
    PlayingBall   *whiteBall;
    Camera        *camera;
    SoundSystem   *soundSystem;
    GameRules     *gameRules;
	HUD			  *hud;
    GameManager   *gameManager;

	AI *bob;
};

#endif
