//Model.h

#ifndef MODEL_H
#define MODEL_H

#include <stdio.h>
#include <string.h>

#include <render/render.h>
#include <geommath/geommath.h>

#include "RenderManager.h"

#define MAX_SIZE 50
#define SCALE_VECTOR Vec4(2048.0f,2048.0f, 0xFFFFFF / 32.0f, 1.0f)

class Model
{
public:
   Model(RenderManager* ptrRMgr);
   ~Model();
   
   void LoadModel(char* modelName);
   void DrawModel(Mat44 &rotation, Mat44 &worldtoscreen, lightinfo &lights);
   void DrawModel(Mat44 &rotation, Mat44 &worldtoscreen, lightinfo &lights, bool kickFrame);

private:
	int LoadObjects(CSceneCreatorIntmd scenecreatorobject, void *meshpointers[], void *texturepointers[], Mat44 transforms[]);

    bool  hasTextures, modelHasLoaded;
	void  *meshaddr[MAX_SIZE], *textureaddr[MAX_SIZE];  // load meshes and textures into data buffer
    Mat44 scenetransform[MAX_SIZE], objecttoworld;
	int   numinstances;
    RenderManager* renderMgr;
};

#endif
