#include "ModelController.h"

Model* ModelController::LoadModel(char* name)
{
    int x = ModelLoaded(name);
    if (x != -1)
        return GetModelPointer(x);
    else
    {
        Model *model = new Model(renderMgr);
        model->LoadModel(name);
        AddModel(model, name);
        return model;
    }
}

Model* ModelController::GetModelPointer(int x)
{   
    return modelArray[x];
}

int ModelController::ModelLoaded(char * name)
{
    for (int i = 0; i < numModels; i++)
    {
        if (strcmp( keyArray[i], name) == 0)
          return i;
    }
    return -1;
}

void ModelController::AddModel(Model *model, char * name)
{
    if (numModels < MAX_MODELS)
    {
        modelArray[numModels] = model;
        keyArray[numModels]   = name;
        ++numModels;
    }
}

ModelController::~ModelController()
{
    for (int i = 0; i < numModels; i++)
        delete modelArray[i];
}

ModelController::ModelController(RenderManager *ptrRMgr)
{
    numModels = 0;
    renderMgr = ptrRMgr;
    for(int i = 0; i < MAX_MODELS; ++i)
        modelArray[i] = NULL;
}