#ifndef PLAYINGBALL_H
#define PLAYINGBALL_H

#include "CObject.h"

#define CUTOFF_VELOCITY 0.05

class PlayingBall : public CObject
{
public:
    PlayingBall(dWorldID world, dSpaceID space, ModelController *modelController, GeomController *geomController, float ballSize, float ballMass, char* modelName, int ballNo, char* ballName, int type);
    ~PlayingBall();

    bool IsStopped();
    void UpdateVelocityStatus();
    int  GetBallType();
    void SetRespawnStatus(bool rStatus);
    bool GetRespawnFromPocketStatus();
    void SetRespawnFromPocketStatus(bool rStatus);
    void Respawn();
    void RemoveFromTable();
    void SetRespawnCoords(float x, float y, float z);
    void SetRemovalCoords(float x, float y, float z);

private:
    dGeomID ballGeom;
    int     ballNumber, ballType, score;
    bool    isStopped, respawn, respawnFromPocket;
    float   respawnCoords[3], removalCoords[3];
};

#endif
