#include "PlayingSurface.h"

PlayingSurface::PlayingSurface(dSpaceID space, ModelController *modelController, GeomController *geomController, char *modelName) : CObject(modelName, modelController, "PlayingSurface")
{
    //Create the planes
    //Table surface
    tableGeom[0] = dCreateBox(space, 1.4, 1.0, 2.6);
    dGeomSetPosition(tableGeom[0], 0.0, -0.5, 0.0);

    //Room walls
    tableGeom[1] = dCreatePlane(space, -1.0, 0.0,  0.0, -2.7);
    tableGeom[2] = dCreatePlane(space,  1.0, 0.0,  0.0, -2.7);
    tableGeom[3] = dCreatePlane(space,  0.0, 0.0, -1.0, -3.3);
    tableGeom[4] = dCreatePlane(space,  0.0, 0.0,  1.0, -3.3);

	//Cushions - end
    tableGeom[5] = dCreateBox(space, 1.043, 0.1, 0.1);
    tableGeom[6] = dCreateBox(space, 1.043, 0.1, 0.1);
	dGeomSetPosition(tableGeom[5], 0.0, 0.05,  1.25);
	dGeomSetPosition(tableGeom[6], 0.0, 0.05, -1.25);

	//Cushions - side
    tableGeom[7] = dCreateBox(space, 0.1, 0.1, 1.0596);
    tableGeom[8] = dCreateBox(space, 0.1, 0.1, 1.0596);
    tableGeom[9] = dCreateBox(space, 0.1, 0.1, 1.0596);
    tableGeom[10] = dCreateBox(space, 0.1, 0.1, 1.0596);
	dGeomSetPosition(tableGeom[7],   0.65, 0.05,  0.5917);
	dGeomSetPosition(tableGeom[8],   0.65, 0.05, -0.5917);
	dGeomSetPosition(tableGeom[9],  -0.65, 0.05,  0.5917);
	dGeomSetPosition(tableGeom[10], -0.65, 0.05, -0.5917);

	//Ball rack
    tableGeom[11] = dCreateBox(space, 1.3, 1.0, 2.5);
    tableGeom[12] = dCreateBox(space, 1.3, 0.2, 0.2);
    tableGeom[13] = dCreateBox(space, 1.3, 0.2, 0.2);
    tableGeom[14] = dCreateBox(space, 0.2, 0.2, 1.7);
    tableGeom[15] = dCreateBox(space, 0.2, 0.2, 1.7);
    tableGeom[16] = dCreateBox(space, 1.3, 1.0, 2.5);
    dGeomSetPosition(tableGeom[11], 0.0, 99.5, 0.0);
    dGeomSetPosition(tableGeom[12], 0.0, 100.1, -1.15);
    dGeomSetPosition(tableGeom[13], 0.0, 100.1, 1.15);
    dGeomSetPosition(tableGeom[14], -0.55, 100.1, 0.0);
    dGeomSetPosition(tableGeom[15], 0.55, 100.1, 0.0);
    dGeomSetPosition(tableGeom[16], 0.0, 100.7, 0.0);

    //Floor
    tableGeom[17] = dCreatePlane(space, 0.0, 1.0, 0.0, -1.0);

    //Register geoms
	int i;
    
	geomController->AddGeom(tableGeom[0], "PlayingSurface", this);
	for( i = 1; i < 5; ++i )
        geomController->AddGeom(tableGeom[i], "Room", this);
    for( i = 5; i < 11; ++i )
        geomController->AddGeom(tableGeom[i], "Cushion", this);
    for( i = 11; i < 17; ++i )
        geomController->AddGeom(tableGeom[i], "PlayingSurface", this);
	geomController->AddGeom(tableGeom[17], "Room", this);
}

PlayingSurface::~PlayingSurface()
{}
