//Inherits from CObject.
//Is the root node in the GameWorld object hierarchy.

#ifndef POOLROOM_H
#define POOLROOM_H

#include "CObject.h"
#include "PlayingSurface.h"
#include "PlayingBall.h"
#include "GameRules.h"
#include "Utensil.h"
#include "Pocket.h"
#include "Constants.h"
#include <ode/ode.h>

#define MAX_POCKETS 6

class PoolRoom : public CObject
{
public:
	PoolRoom(GameRules *rules, dWorldID world, dSpaceID space, ModelController *modelController, GeomController *geomController);
	~PoolRoom();

    void DrawUtensil(Mat44 worldtoscreen, lightinfo lights);
    void ResetBallPositions();
	PlayingBall* GetWhiteBall();
    void UpdateBallVelocities();
    bool AllBallsStopped();
    PlayingSurface* GetPlayingSurface();
	void RespawnBalls();
    PlayingBall* GetPlayingBall(int ballNo);
    void ResetAllBalls();
    Utensil* GetUtensil();
    CObject *target;
    CObject *targetPocket;
    CObject *targetBall;
    CObject *startingPoint;

private:
	PlayingSurface *playingSurface;
    Utensil        *utensil;
	GameRules	   *gameRules;
	PlayingBall    *playingBalls[MAX_BALLS];
    Pocket         *pockets[MAX_POCKETS];
    dGeomID        roomGeoms[6];
};

#endif
