//RenderManager.cpp

#include "RenderManager.h"

RenderManager::RenderManager(int iSps2descriptor)
{
    maxObjects     = 10;
    currentObjects = 0;
    sps2descriptor = iSps2descriptor;
    kicksettings   = Render_GetDMASetup();  //SET up the DMA channels
}

RenderManager::~RenderManager()
{}

void RenderManager::DrawingObject()
{
    currentObjects++;

    if(currentObjects == maxObjects)
    {
        Render_AddEndTag();
        Render_SetBGColour(0x000000); 						// dma timing
        sps2WaitForDMA(1, sps2descriptor); 					// make sure frame is drawn
        Render_SetBGColour(0x000000); 						// finished this frame
        Render_KickDMA(sps2descriptor, kicksettings);
        Render_SwapChainBuffers();

        currentObjects = 0;
    }
}

void RenderManager::FinishedFrame()
{
    Render_AddEndTag();
    Render_SetBGColour(0x000000); 						// dma timing
    sps2WaitForDMA(1, sps2descriptor); 					// make sure frame is drawn
    Render_SetBGColour(0x000000); 						// finished this frame
    Render_KickDMA(sps2descriptor, kicksettings);
    Render_SwapChainBuffers();

    Render_SetBGColour(0x000000); 						// dma timing
    sps2WaitForDMA(1, sps2descriptor); 					// make sure frame is drawn
	Render_SetBGColour(0x000000); 

    currentObjects = 0;
}
