//SoundSystem.cpp

#include "SoundSystem.h"

SoundSystem::SoundSystem()
{
    soundlib_initialize(MAX_SOUNDS, 0, 0, 0);
}

SoundSystem::~SoundSystem()
{
    soundlib_shutdown();
}

void SoundSystem::PlaySound(int soundID)
{
    soundlib_play_sound(soundID, 0, 0, SOUND_PLAY_BEGINNING);
}

void SoundSystem::PlaySound(int soundID, float volume)
{
    soundlib_set_sound_volume(soundID, volume);
    soundlib_play_sound(soundID, 0, 0, SOUND_PLAY_BEGINNING);
}

int SoundSystem::LoadSound(char* fileName)
{
    return (soundlib_create_sound_from_file(fileName, 0, 0));
}

void SoundSystem::Update()
{
    soundlib_update();
}

void SoundSystem::ToggleMusic(int musicID)
{
	musicPlaying = !musicPlaying;
	if(musicPlaying)
		soundlib_play_sound(musicID, 0, 1, SOUND_PLAY_BEGINNING);
	else
		soundlib_stop_sound(musicID);
}
